      program driver4
c     Xu interpolation on the cardioid (see at the bottom)
      implicit none
      integer degmax,nxuptm,ntgptm,nx,type,dim
      parameter (degmax=1000,nxuptm=degmax*(degmax+2)/2,ntgptm=50000,
     1     dim=2)
      integer nxupt,ntgpt,deg,i
      double precision scale1,shift1,scale2,shift2,funct,passo,err,
     1     x1,x2
      external funct,transform
      double precision vertex(4),xupt(nxuptm),yupt(nxuptm),
     1     fxupt(nxuptm),xtgpt(ntgptm),ytgpt(ntgptm),ftgpt(ntgptm),
     2     poltgt(ntgptm)
      open(5,file='input4',status='old')
      read(5,*) (vertex(i),i=1,4)
      scale1=(vertex(2)-vertex(1))/2
      shift1=vertex(1)+scale1
      scale2=(vertex(4)-vertex(3))/2
      shift2=vertex(3)+scale2
      read(5,*) type
      read(5,*) nx
      if (type.gt.1) then
         ntgpt=nx**2
         passo=2.d0/(nx-1)
      else
         ntgpt=nx
      end if   
      read(5,*) deg
      close(5)
c     
c     Target points on square
c
      write(20,*) '# Function at ',ntgpt,' target points'
      do i=1,ntgpt
         call getnode(i,nx,passo,x1,x2,type)
         xtgpt(i)=scale1*x1+shift1
         ytgpt(i)=scale2*x2+shift2
         ftgpt(i)=funct(xtgpt(i),ytgpt(i),transform)
         call transform(xtgpt(i),ytgpt(i),x1,x2)
         write(20,1) x1,x2,ftgpt(i)
      end do   
c
c     Xu points on square
c
      call bldxu(deg,xupt,yupt,nxupt)
      write(21,*) '# Function at ',nxupt,' Xu points'
      do i=1,nxupt
         x1=scale1*cos(xupt(i))+shift1
         x2=scale2*cos(yupt(i))+shift2
         fxupt(i)=funct(x1,x2,transform)
         call transform(x1,x2,x1,x2)
         write(21,1) x1,x2,fxupt(i)
      end do   
      write(6,*) 'Computing the interpolant...'
      call interp(deg,xupt,yupt,fxupt,nxupt,xtgpt,ytgpt,
     1     poltgt,ntgpt,scale1,shift1,scale2,shift2)
      write(6,*) 'Writing interpolant...'
      write(22,*) '# Interpolant at ',ntgpt,' target points'
      do i=1,ntgpt
         call transform(xtgpt(i),ytgpt(i),x1,x2)
         write(22,1) x1,x2,poltgt(i)
      end do   
      write(6,*) 'Computing errors...'
      err=0.0d0
      do i=1,ntgpt
         err=max(err,abs(poltgt(i)-ftgpt(i)))
      end do   
      write(6,2) 'Xu error on target points ',err
      write(6,*)
      write(6,*) 'Function on target points on fort.20'
      write(6,*) 'Function on Xu points on     fort.21'
      write(6,*) 'Xu on target points on       fort.22'
 1    format(3(1x,e23.16))
 2    format(1x,a26,1x,e9.3)
      stop
      end

      subroutine transform(x,y,xt,yt)
      double precision x,y,xt,yt
      call cardioid(x,y,xt,yt)
      return
      end
