      subroutine FunLeb(m,n,vertic,tol,epsilon,nmax,points,mesh)
      implicit none
c
c     Lebesgue function for Xu interpolant
c
      integer m,n,mesh,nmax
c
c      
      double precision tol,epsilon,vertic(4)
c
c
      integer i,j,k,kmax,cont1,cont2
c
c     i,j,k,kmax counters
c
      double precision passo,x1,x2,valF,Lag,massimo,y1,y2,
     1     p,temp1,den,shift1,shift2,scale1,scale2,x1ss,x2ss,x1max,
     2     x2max,points(2,*)
      data p/3.141592653589793d0/,massimo/0.0d0/,passo/0.0d0/
      data cont1/0/,cont2/0/
c     
c     open file 'interp.out' for results
c
      open(12,file='funleb.out',status='unknown')
      write(12,'(a36)') '#  x1             x2             val'
      temp1=p/n
      scale1=(vertic(2)-vertic(1))/2
      scale2=(vertic(4)-vertic(3))/2
      shift1=vertic(1)+scale1
      shift2=vertic(3)+scale2
      if ((mesh.eq.0).or.(mesh.eq.1)) then
c     
c     read form std input or random
         kmax=m-1
      else 
c     uniform grid
         passo=2.0d0/(m-1)
         kmax=m**2-1
      end if   
      do k=0,kmax
         call getnode(k,m,passo,points,x1,x2,mesh)
         x1ss=scale1*x1+shift1
         x1=acos(x1)
         x2ss=scale2*x2+shift2
         x2=acos(x2)
         valF=0.d0        
         do i=0,n,2
            y1=i*temp1
            do j=1,n-1,2
               y2=j*temp1
               den=n**2
               if ((i.eq.0).or.(i.eq.n)) den=2*den
               call lagran(lag,n,i,y1,y2,x1,x2,tol,epsilon,nmax,
     1              cont1,cont2)
               valF=valF+abs(lag)/den
               call lagran(lag,n,j,y2,y1,x1,x2,tol,epsilon,nmax,
     3              cont1,cont2)
               valf=valF+abs(lag)/den
            end do
         end do
         write(12,'(3(1x,e14.8))') x1ss,x2ss,valF
         if (valF.gt.massimo) then
            x1max=x1ss
            x2max=x2ss
            massimo=valF
         end if   
      end do
      close(12)
      write(6,*) 
      write(6,'(1x,a27,1x,e14.8,1x,a4,1x,e14.8,a1,e14.8,a1)') 
     1     'Maximum Lebesgue function =',massimo,'on (',
     2     x1max,',',x2max,')'
      return
      end
